#define MAXCALLNAMELEN			32

#define call(id,name) callidname(&calls,id,name)

struct scalllist {
    char name[MAXCALLNAMELEN];
    Function f;
    struct scalllist *next;
};

struct scall {
    int id;
    struct scalllist *list;
    struct scall *next;
};

struct scalllistlist {
    char *name;
    Function f;
};

int addcall(struct scall **list, int id);
int delcall(struct scall **list, int id);
int freecall(struct scall **list);
int addcallid(struct scall **list, int id, char *name, Function f);
int addcallidlist(struct scall **list, int id, struct scalllistlist *clist);
int delcallid(struct scall **list, int id, char *name);
int delcallidlist(struct scall **list, int id, struct scalllistlist *clist);
int freecallid(struct scall **list, int id);
int freecalllist(struct scalllist **list);
Function callidname(struct scall **list, int id, char *name);
